﻿////using System;
////using System.Windows;
////using System.Windows.Controls;
////using System.Windows.Input;
////using System.Windows.Media;
////using System.Windows.Media.Animation;
////using Telerik.Windows.QuickStart.Common;

////namespace Telerik.Windows.QuickStart
////{
////    public partial class BouncePanel : Panel
////    {
////        #region private members
////        private static uint instanceCount;
////        private static uint currentInstance;
////        private double elementOriginalHeight = 100;
////        #endregion

////        #region - Attached properies -
////        internal static FrameworkElement GetShadowElement(DependencyObject obj)
////        {
////            return (FrameworkElement)obj.GetValue(ShadowElementProperty);
////        }

////        internal static void SetShadowElement(DependencyObject obj, FrameworkElement value)
////        {
////            obj.SetValue(ShadowElementProperty, value);
////        }

////        internal static readonly DependencyProperty ShadowElementProperty =
////            DependencyProperty.RegisterAttached("ShadowElement", typeof(FrameworkElement), typeof(BouncePanel), null);

////        internal static CustomStoryboard GetElementAnimation(DependencyObject obj)
////        {
////            return (CustomStoryboard)obj.GetValue(ElementAnimationProperty);
////        }

////        internal static void SetElementAnimation(DependencyObject obj, CustomStoryboard value)
////        {
////            obj.SetValue(ElementAnimationProperty, value);
////        }

////        internal static readonly DependencyProperty ElementAnimationProperty =
////            DependencyProperty.RegisterAttached("ElementAnimation", typeof(CustomStoryboard), typeof(BouncePanel), null);

////        internal static int GetChildInstanceCount(DependencyObject obj)
////        {
////            return (int)obj.GetValue(ChildInstanceCountProperty);
////        }

////        internal static void SetChildInstanceCount(DependencyObject obj, int value)
////        {
////            obj.SetValue(ChildInstanceCountProperty, value);
////        }

////        internal static readonly DependencyProperty ChildInstanceCountProperty =
////            DependencyProperty.RegisterAttached("ChildInstanceCount", typeof(int), typeof(BouncePanel), null);

////        #endregion - 

////        #region - const variables -
////        private readonly double TRANSLATE_TRANSFORM_MIN_Y = 0;
////        #endregion

////        public BouncePanel()
////            : base()
////        {
////            Background = new SolidColorBrush(Colors.Transparent);
////            ++instanceCount;

////            Loaded += OnLoaded;

////#if WPF
////            Unloaded += BouncePanel_Unloaded;
////#endif
////        }

////        #region - Dependancy properties -

////        public static readonly DependencyProperty BAnimationDuration =
////            DependencyProperty.Register("BounceDurationInMilliseconds", typeof(int), typeof(BouncePanel), new PropertyMetadata(150));

////        public int BounceNumber
////        {
////            get
////            {
////                return (int)GetValue(BounceNumberProperty);
////            }
////            set
////            {
////                if (value > 0)
////                {
////                    SetValue(BounceNumberProperty, value);
////                }
////            }
////        }

////        public static readonly DependencyProperty BounceNumberProperty =
////            DependencyProperty.Register("BounceNumber", typeof(int), typeof(BouncePanel), new PropertyMetadata(2));

////        public static readonly DependencyProperty CreateReflectionProperty =
////            DependencyProperty.Register("CreateReflection", typeof(bool), typeof(BouncePanel), new PropertyMetadata(false));

////        public DependencyObject ChildElement
////        {
////            get { return (DependencyObject)GetValue(BouncePanelContentProperty); }
////            set { SetValue(BouncePanelContentProperty, value); }
////        }

////        public static readonly DependencyProperty BouncePanelContentProperty =
////            DependencyProperty.Register("BouncePanelContent", typeof(DependencyObject), typeof(BouncePanel), null);

////        public int BounceDurationInMilliseconds
////        {
////            get { return (int)GetValue(BAnimationDuration); }
////            set { SetValue(BAnimationDuration, value); }
////        }

////        public bool CreateReflection
////        {
////            get { return (bool)GetValue(CreateReflectionProperty); }
////            set { SetValue(CreateReflectionProperty, value); }
////        }

////        #endregion

////        private void BouncePanel_Unloaded(object sender, RoutedEventArgs e)
////        {
////            --instanceCount;
////            --currentInstance;
////        }
       
////        private void OnLoaded(object sender, RoutedEventArgs e)
////        {
////            double beginTime = instanceCount + currentInstance++ * 200;
////            if (Children.Count > 1)
////            {
////                throw new ArgumentException("The property 'Content' is set more than once");
////            }

////            FrameworkElement control = ChildElement as FrameworkElement;
////#if WPF
////            control.Loaded += this.control_Loaded;
            
////#endif
////            elementOriginalHeight = Double.IsNaN(control.Height) ? control.DesiredSize.Height : control.Height;
            
////            TransformGroup transformGroup = new TransformGroup();
////            transformGroup.Children.Add(new TranslateTransform() { X = 0, Y = -elementOriginalHeight / 2 });

////            control.RenderTransform = transformGroup;
////            control.MouseEnter += this.OnMouseOver;
////            control.MouseLeave += this.OnMouseLeave;
////            control.MouseLeftButtonDown += this.Control_MouseLeftButtonDown;

////            if (control is Image)
////            {
////                CreateReflectionCopy(control, beginTime);
////            }

////            StartAnimation(control, 
////                           TRANSLATE_TRANSFORM_MIN_Y, 
////                           200,
////                           TimeSpan.FromMilliseconds(beginTime), 
////                           BounceNumber);

////            Loaded -= OnLoaded;
////        }

////        private void Control_Loaded(object sender, RoutedEventArgs e)
////        {
////           Image clone = GetShadowElement(sender as DependencyObject) as Image;

////           clone.Source = (sender as Image).Source;
////        }

////        private void Control_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
////        {
////            OnMouseLeave(sender, e);
////        }

////        private void OnMouseOver(object sender, MouseEventArgs e)
////        {
////            Cursor = Cursors.Hand;
////            FrameworkElement element = (sender as FrameworkElement);
////            CustomStoryboard storyBoard = GetElementAnimation(element);

////            if (CreateReflection)
////            {
////                CreateShadowAnimation(element, .1, 0);
////            }

////            if (storyBoard != null && !storyBoard.IsFinished)
////            {
////                return;
////            }

////            double height = double.IsNaN(element.Height) ? element.DesiredSize.Height : element.Height;
////            height /= height < 70 ? 5 : 10;

////            StartAnimation(element,
////                           -(TRANSLATE_TRANSFORM_MIN_Y + height),
////                           BounceDurationInMilliseconds,
////                           TimeSpan.Zero,
////                           0);
////        }

////        private void OnMouseLeave(object sender, MouseEventArgs e)
////        {
////            FrameworkElement element = (sender as FrameworkElement);

////            if (CreateReflection)
////            {
////                CreateShadowAnimation(element, .5, 0);
////            }

////            StartAnimation(element,
////                          -TRANSLATE_TRANSFORM_MIN_Y,
////                          BounceDurationInMilliseconds,
////                          TimeSpan.Zero,
////                          BounceNumber);
////        }

////        private void StartAnimation(FrameworkElement childElement,
////                                    double to,
////                                    double duration,
////                                    TimeSpan beginTime,
////                                    double bounceNumber)
////        {
////            DoubleAnimation animation = new DoubleAnimation();
////            animation.Duration = TimeSpan.FromMilliseconds(duration);
////            animation.BeginTime = beginTime;
////            animation.To = to;

////            string propertyName = "(UIElement.RenderTransform).(TransformGroup.Children)[0].(TranslateTransform.Y)";

////            CustomStoryboard moveAnimation = new CustomStoryboard(childElement, propertyName, animation);
////            SetElementAnimation(childElement, moveAnimation);
////            moveAnimation.AnimationCompleted +=
////                (sender, e) =>
////                {
////                    if (bounceNumber > 1)
////                    {
////                        double to_Y = UpdateTransformYValue(ref bounceNumber, to);

////                        if (to == 0)
////                        {
////                            CreateDummyAnimation(childElement, childElement.ActualHeight - 5);
////                        }
////                        StartAnimation(childElement, -to_Y, BounceDurationInMilliseconds, TimeSpan.Zero, bounceNumber);
////                    }
////                };
////            moveAnimation.StartAnimation(this);
////        }

////        private void CreateDummyAnimation(FrameworkElement childElement, double to)
////        {
////            DoubleAnimation animation = new DoubleAnimation()
////            {
////                Duration = TimeSpan.FromMilliseconds(50),
////                From = elementOriginalHeight,
////                To = to
////            };

////            CustomStoryboard moveAnimation = new CustomStoryboard(childElement, "Height", animation);
////            moveAnimation.AnimationCompleted += MoveAnimation_AnimationComplated;
////            moveAnimation.StartAnimation(this);
////        }

////        private void MoveAnimation_AnimationComplated(object sender, AnimationEventArgs e)
////        {
////            DoubleAnimation animation = new DoubleAnimation()
////            {
////                To = elementOriginalHeight + 5,
////                Duration = TimeSpan.FromMilliseconds(BounceDurationInMilliseconds)
////            };

////            CustomStoryboard moveAnimation = new CustomStoryboard(e.AnimatedObject, "Height", animation);
////            moveAnimation.StartAnimation(this);
////        }

////        private double UpdateTransformYValue(ref double bounceNumbera, double toY)
////        {
////            double tempToY = elementOriginalHeight - ((elementOriginalHeight - TRANSLATE_TRANSFORM_MIN_Y) / bounceNumbera);
////            tempToY /= 10;

////            if (-tempToY == toY)
////            {
////                --bounceNumbera;
////                tempToY = TRANSLATE_TRANSFORM_MIN_Y;
////            }
////            return tempToY;
////        }

////        private void CreateReflectionCopy(FrameworkElement control, double beginTime)
////        {
////            Children.Remove(control);

////            StackPanel parentControl = new StackPanel() { Orientation = Orientation.Vertical };
////            FrameworkElement elementClone;

////            parentControl.Children.Add(control);

////            if (CreateReflection)
////            {
////                Image image = control as Image;
////                if (image != null)
////                {
////                    elementClone = new Image();
////                    elementClone.SetValue(Image.StretchProperty, Stretch.Fill);
////                    elementClone.SetValue(Image.SourceProperty, image.Source);
////                    elementClone.SetValue(FrameworkElement.StyleProperty, GetImageStyle());

////                    SetShadowElement(image, elementClone);
////                }
////                else
////                {
////                    elementClone = new TextBlock();
////                }

////                double width = Double.IsNaN(control.Width) ? control.ActualWidth : control.Width;
////                double height = Double.IsNaN(control.Height) ? control.ActualHeight : control.Height;

////                elementClone.Margin = new Thickness(control.Margin.Left,
////                                                    height / 2 + 2,
////                                                    control.Margin.Right,
////                                                    control.Margin.Bottom);

////                elementClone.SetValue(FrameworkElement.WidthProperty, width);
////                elementClone.SetValue(FrameworkElement.HeightProperty, height / 2);
                
////                parentControl.Children.Add(elementClone);
////            }

////            this.Children.Add(parentControl);

////            if (CreateReflection)
////            {
////                CreateShadowAnimation(control, .5, beginTime);
////            }
////        }

////        private static Style GetImageStyle()
////        {
////            return Utils.GetSpecificStyle("ElementShadow", "/Telerik.Windows.QuickStart;component/Themes/ShadowImage.xaml");
////        }

////        private void CreateShadowAnimation(FrameworkElement sender, double value, double beginTime)
////        {
////            FrameworkElement shadowElement = GetShadowElement(sender);
////            if (shadowElement != null)
////            {
////                DoubleAnimation animation = new DoubleAnimation();
////                animation.BeginTime = TimeSpan.FromMilliseconds(beginTime);
////                animation.Duration = TimeSpan.FromMilliseconds(this.BounceDurationInMilliseconds);
////                animation.To = value;

////                CustomStoryboard moveAnimation = new CustomStoryboard(shadowElement, "Opacity", animation);
////                moveAnimation.StartAnimation(this);
////            }
////        }

////        #region - override methods - 
////        protected override Size MeasureOverride(Size availableSize)
////        {
////            int childCount = Children.Count;

////            foreach (UIElement element in Children)
////            {
////                element.Measure(new Size(availableSize.Width / childCount, availableSize.Height / childCount));
////            }

////            return this.Children.GetDesiredSize();
////        }

////        protected override Size ArrangeOverride(Size finalSize)
////        {
////            double y = 0;

////            foreach (UIElement element in Children)
////            {
////                double width = element.DesiredSize.Width;

////                element.Arrange(new Rect(y, 0, element.DesiredSize.Width, element.DesiredSize.Height));
////                y += width + 10;
////            }

////            return this.Children.GetDesiredSize();
////        }
        
////        #endregion
////    }

////    internal static class ExtensionBouncePanel
////    {
////        public static Size GetDesiredSize(this UIElementCollection collection)
////        {
////            double width = 0;
////            double height = 0;

////            foreach (UIElement element in collection)
////            {
////                width += element.DesiredSize.Width;
////                height += element.DesiredSize.Height;
////            }

////            return new Size(width, height);
////        }
////    }
////}
