﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Data;

namespace Telerik.Windows.QuickStart
{
#if WPF
	/// <summary>
    /// Converts all characters of a string to upper case
    /// </summary>
    public class ToUppercaseConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (targetType != typeof(string))
                throw new InvalidOperationException("Only string type is supported");

            if (value == null)
                return null;

            return value.ToString().ToUpperInvariant();
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

#endif
}
